(deffacts date
 (queen 1 3)
 (dim 8)
 (faza explore)
 (explore 2 1)
)

(deffunction q-attack (?l1 ?c1 ?l2 ?c2)
  (or (eq ?l1 ?l2) 
      (eq ?c1 ?c2)
      (eq (abs (- ?l1 ?l2)) (abs (- ?c1 ?c2))))
)

(defrule 8q-explore-true
 (declare (salience -10))
 (faza explore)
 (dim ?n)
 ?e <- (explore ?le ?ce)
 (queen ?l ?c)
 (test (not (q-attack ?le ?ce ?l ?c)))
 => 
 (retract ?e)
 (assert (queen ?le ?ce)
         (explore (+ ?le 1) 1))
)

(defrule 8q-finish
 (declare (salience 100))
 ?f <- (faza explore)
 (dim ?n)
 (queen ?n ?)
 =>
 (retract ?f)
 (assert (faza print ?n))
)

(defrule print
 ?f <- (faza print ?l&:(> ?l 0))
 (queen ?l ?c)
 =>
 (retract ?f)
 (printout t "line " ?l " col " ?c crlf)
 (assert (faza print (- ?l 1)))
)

(defrule 8q-explore-false
 (faza explore)
 (dim ?n)
 ?e <- (explore ?le ?ce&:(< ?ce ?n))
 (queen ?l ?c)
 (test (q-attack ?le ?ce ?l ?c))
 => 
 (retract ?e)
 (assert (explore ?le (+ ?ce 1)))
)

(defrule 8q-explore-false-right
 ?f <- (faza explore)
 (dim ?n)
 ?e <- (explore ?le&:(> ?le 1) ?n)
 (queen ?l ?c)
 (test (q-attack ?le ?n ?l ?c))
 => 
 (retract ?e ?f)
 (assert (faza backtrack (- ?le 1)))
)

(defrule 8q-backtrack-ok
 (dim ?n)
 ?f <- (faza backtrack ?lb&:(> ?lb 1))
 ?q <- (queen ?lb ?c&:(< ?c ?n))
 =>
 (retract ?f ?q)
 (assert (explore ?lb (+ ?c 1))
         (faza explore))
)

(defrule 8q-backtrack-no
 (dim ?n)
 ?f <- (faza backtrack ?lb&:(> ?lb 1))
 ?q <- (queen ?lb ?n)
 =>
 (retract ?f ?q)
 (assert (faza backtrack (- ?lb 1)))
)

(defrule 8q-backtrack-fail
 (dim ?n)
 ?f <- (faza backtrack 1)
 ?q <- (queen 1 ?n)
 =>
 (retract ?f ?q)
 (printout t "FAIL!" ctrl)
)



 